#%%define %_libexecdir %_sbindir
%define svn 1

Name: mailfromd

%define baseversion 5.0.90

%if %svn
%define svndate 20090320
Version: %baseversion
Release: alt0.%svndate.3
%define srcdir %name-%baseversion-%svndate
%else
Version: %baseversion
Release: alt1.0
%define srcdir %name-%version
%endif

Packager: Sergey Y. Afonin <asy@altlinux.ru>

Summary: Universal flexible smtp data supervisor for Sendmail, MeTA1 and Postfix

License: %gpl3plus
Group: System/Servers
Requires: %name-config makemap m4

Url: http://puszcza.gnu.org.ua/projects/mailfromd/
%if %svn
Source0:        %name-%baseversion-%svndate.tar.gz
%else
Source0:        %name-%version.tar.gz
%endif

Source10: mailfromd.init
Source11: mailfromd.sysconfig
Source12: mailfromd-Makefile
Source13: mailfromd-cron

Source20: mailfromd.rc
Source21: mailfromd-localconf.rc
Source22: mailfromd-userfunctions.rc

Source30: mailfromd-whitelist.main
Source31: mailfromd-sendmail.wl
Source32: mailfromd-shared.wl

Source50: mailfromd-clamav_only.rc

#Patch0:

#Source100: mailfromd-svn20070425.patch
#Patch101: mailfromd-lock_remove.patch
#Patch102: mailfromd-engine.c.patch


# Automatically added by buildreq on Mon Mar 16 2009
BuildRequires: emacs-X11 emacs-cedet-speedbar emacs-git flex-old libdb4-devel libldap-devel libmailutils-devel libncurses-devel libpam-devel libreadline-devel mailutils

BuildRequires: rpm-build-licenses
BuildRequires: libmailutils-devel >= 2.0

#BuildRequires: emacs-common flex-old libdb4-devel libldap-devel libncurses-devel libpam-devel libreadline-devel mailutils

%description
Milter-filter for Sendmail v8, MeTA1 and Postfix (since 2.3; please look
documentation of Postfix for checking some limitations).
It provide many verifications at different stages of reception of the messages,
including smtp callback checking, gray listing, regexp checking, ClamAV and
SpamAssassin lookup and other. Nominally it is replacement for verify_sender,
milter-regex, clamav-milter, milter-greylist ang other.

%package cfg_full
Summary: Full featured configuration of mailfromd.
Copyright: %gpl3plus
Requires: %name = %version-%release
Provides: %name-config
Group: System/Servers
BuildArch: noarch

%description cfg_full
Full featured configuration of mailfromd.

%package cfg_clamav
Summary: clamav-milter replacement configuration.
Copyright: %gpl3plus
Requires: %name = %version-%release
Provides: %name-config
Group: System/Servers
BuildArch: noarch

%description cfg_clamav
clamav-milter replacement configuration.

%package doc
Summary: Documentation for mailfromd.
Copyright: %fdl
Prereq: /sbin/install-info
Group: Development/Documentation
BuildArch: noarch

%description doc
Documentation for mailfromd.

%package mfl
Summary: GNU Emacs MFL extention for mailfromd.
Copyright: %gpl3plus
Requires: emacs-base
Group: System/Servers
BuildArch: noarch

%description mfl
MFL sources are usual ASCII files and you may edit them with any editor
you like.  However, the best choice for this job (as well as for many
others) is, without doubt, GNU Emacs.  To ease the work of editing
script files, the `mailfromd' package provides a special Emacs mode,
called "MFL mode".

%package locales
Summary: National Language files for mailfromd
Copyright: %gpl3plus
Group: System/Servers
BuildArch: noarch

%description locales
National Language files for mailfromd (Polish and Ukrainian)

%prep

%setup -q -n %srcdir

# patch0 -p0

#patch100
# patch -l -p0 < SOURCE100
# patch101 -p0
# patch102 -p0

%build

#autoreconf

%undefine __libtoolize

export LIBS="-lresolv"
%configure --libexecdir=%_sbindir --sysconfdir=%_sysconfdir/mailfromd --with-berkeley-db
# --enable-syslog-async

#%if %svn
#make ChangeLog
#%endif

%__gzip ChangeLog

# NO SMP BUILD
%make

%install
#%__mkdir_p %buildroot/%_bindir

make install DESTDIR=%buildroot
install -d $RPM_BUILD_ROOT%_localstatedir/mailfromd-clamav


install -d $RPM_BUILD_ROOT%{_sysconfdir}/{rc.d/init.d,sysconfig,cron.daily}
install -d $RPM_BUILD_ROOT%{_sysconfdir}/mailfromd/{config.d,config.d.shared}

#install -d $RPM_BUILD_ROOT%_localstatedir/mailfromd

touch $RPM_BUILD_ROOT%_sysconfdir/mailfromd/whitelist
touch $RPM_BUILD_ROOT%_sysconfdir/mailfromd/whitelist.db

%__sed -e 's|@@CFG_NAME@@|mailfromd|g' < %SOURCE10 > $RPM_BUILD_ROOT%_initdir/mailfromd
%__chmod 755 $RPM_BUILD_ROOT%_initdir/mailfromd
%__sed -e 's|@@CFG_NAME@@|mailfromd|g' < %SOURCE11 > $RPM_BUILD_ROOT%_sysconfdir/sysconfig/mailfromd

install -m744 %SOURCE13 $RPM_BUILD_ROOT%_sysconfdir/cron.daily/mailfromd

%__cp -f %SOURCE12 $RPM_BUILD_ROOT%_sysconfdir/mailfromd/Makefile

%__cp -f %SOURCE20 $RPM_BUILD_ROOT%_sysconfdir/mailfromd/mailfromd.rc
%__cp -f %SOURCE21 $RPM_BUILD_ROOT%_sysconfdir/mailfromd/localconf.rc
%__cp -f %SOURCE22 $RPM_BUILD_ROOT%_sysconfdir/mailfromd/userfunctions.rc

install -m644 %SOURCE30 $RPM_BUILD_ROOT%_sysconfdir/mailfromd/whitelist.main
install -m644 %SOURCE31 $RPM_BUILD_ROOT%_sysconfdir/mailfromd/config.d/sendmail.wl
install -m644 %SOURCE32 $RPM_BUILD_ROOT%_sysconfdir/mailfromd/config.d.shared/shared.wl

%find_lang mailfromd

#
# cfg_clamav
#
pushd $RPM_BUILD_ROOT%_sbindir
    ln -s mailfromd mailfromd-clamav
popd

%__sed -e 's|@@CFG_NAME@@|mailfromd-clamav|g' < %SOURCE10 > $RPM_BUILD_ROOT%_initdir/mailfromd-clamav
%__chmod 755 $RPM_BUILD_ROOT%_initdir/mailfromd-clamav
%__sed -e 's|@@CFG_NAME@@|mailfromd-clamav|g' < %SOURCE11 > $RPM_BUILD_ROOT%_sysconfdir/sysconfig/mailfromd-clamav

%__cp -f %SOURCE50 $RPM_BUILD_ROOT%_sysconfdir/mailfromd/mailfromd-clamav.rc

%post

#{
#
#for serv_name in `ls /usr/sbin/mailfrom* | sed -e "s|.*/\(.*\)|\1|"` ; do
#    service $serv_name rmdb
#    killall -HUP $serv_name
#done
#
#} &>/dev/null ||:

#service crond restart

%preun
#preun_service mailfromd
#service crond restart

%post cfg_full
{
    pushd %_sysconfdir/mailfromd
    make
    popd

} &>/dev/null ||:
%post_service mailfromd
rm -f %_localstatedir/mailfromd/*.db &>/dev/null ||:

%preun cfg_full
%preun_service mailfromd

%post cfg_clamav
{
    pushd %_sysconfdir/mailfromd
    make
    popd

} &>/dev/null ||:
%post_service mailfromd-clamav
rm -f %_localstatedir/mailfromd-clamav/*.db &>/dev/null ||:

%preun cfg_clamav
%preun_service mailfromd-clamav

%preun doc
%uninstall_info

%post doc
%install_info

%files
%dir %_sysconfdir/mailfromd
%dir %_sysconfdir/mailfromd/config.d
%dir %_sysconfdir/mailfromd/config.d.shared

%config(noreplace) %_sysconfdir/mailfromd/localconf.rc
%config(noreplace) %_sysconfdir/mailfromd/userfunctions.rc
%config(noreplace) %_sysconfdir/mailfromd/Makefile

%config %_sysconfdir/cron.daily/mailfromd

%config(noreplace) %_sysconfdir/mailfromd/whitelist.main
%config %_sysconfdir/mailfromd/config.d/sendmail.wl
%config(noreplace) %_sysconfdir/mailfromd/config.d.shared/shared.wl

%ghost %_sysconfdir/mailfromd/whitelist
%ghost %_sysconfdir/mailfromd/whitelist.db

#%_libexecdir/mailfromd
%_sbindir/mailfromd
%_sbindir/pies
%_sbindir/smap
%_bindir/mtasim

%dir %_datadir/mailfromd
%dir %_datadir/mailfromd/%baseversion
%dir %_datadir/mailfromd/%baseversion/include
%_datadir/mailfromd/%baseversion/include/*

%attr(3775,root,mail) %dir %_localstatedir/mailfromd

%files cfg_full
%attr(0755,root,root) %_initdir/mailfromd

%config(noreplace) %_sysconfdir/mailfromd/mailfromd.rc
%config(noreplace) %_sysconfdir/sysconfig/mailfromd

%attr(3775,root,mail) %dir %_localstatedir/mailfromd

%files cfg_clamav
%_sbindir/mailfromd-clamav
%attr(0755,root,root) %_initdir/mailfromd-clamav

%config(noreplace) %_sysconfdir/mailfromd/mailfromd-clamav.rc
%config(noreplace) %_sysconfdir/sysconfig/mailfromd-clamav

%attr(3775,root,mail) %dir %_localstatedir/mailfromd-clamav

%files doc
%doc COPYING README AUTHORS INSTALL NEWS THANKS ChangeLog.gz
%_infodir/*

%files mfl
%_datadir/emacs/site-lisp/*

%files locales -f mailfromd.lang

%changelog
* Mon Apr 06 2009 Sergey Y. Afonin <asy@altlinux.ru> 5.0.90-alt0.20090320.3
- changes in mailfromd.rc and localconf.rc
  renamed spamcheckactive to spam_verification_needed
  updated massallocated_regexps
  updated good_mx
  better logging graylisted reason

* Fri Apr 03 2009 Sergey Y. Afonin <asy@altlinux.ru> 5.0.90-alt0.20090320.2
- fixed: remove last dot in `hostname' output if it there
  (/etc/sysconfig/mailfromd)

* Fri Mar 20 2009 Sergey Y. Afonin <asy@altlinux.ru> 5.0.90-alt0.20090320.1
- new snapshot
- changes in mailfromd.rc
  ignoring smtp callback if mx matches %%not_verifiable_mx and message graylisted.

* Thu Mar 12 2009 Sergey Y. Afonin <asy@altlinux.ru> 5.0.90-alt0.20090311.1
- new snapshot
- changes in mailfromd.rc
  fixed: added variables for SA support to mailfromd.rc

* Wed Nov 12 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.9.96-alt0.20081111.1
- new svn
- changes in mailfromd.rc
  added
   "tolower" call for *.db lookup
   partial lookup access.db of sendmail (see %%mta in rc)
   configuration for spamd (Spamassassin)

* Thu Oct 16 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.9.95-alt0.20081016.1
- new svn
- moved %%configure to %%build (thanks to Led for point this)
- changed emacs-X11 to emacs-nox in BuildRequires (thanks to Led for point this)
- added %%install_info/%%uninstall_info to doc package

* Mon Sep 22 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.9.93-alt1.20080920.1
- new svn

* Wed Jul 16 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.9.92-alt1.20080704.1
- new svn
- changes in mailfromd.rc
  added check for bad "mail from" (%%bad_mail_from = ".*\\|.*" by default)

* Sat May 31 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.9.92-alt1.20080516.2
- changes in mailfromd.rc
  added callback_chk_exclude list
  added graylist_exclude list
  changed gltime interval to 25 minutes

* Thu May 22 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.9.92-alt1.20080516.1
- fixed: removal *.db is restored in mailfromd's localstatedir in %%post of cfg_*
- changes in mailfromd.rc
  rewrote log_header_line: behavior of substring() was changed in mainstream

* Sat May 17 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.9.92-alt1.20080516
- new svn
- changed %%make_build to %%make in spec (a problem with SMP build since branch 4.1)

* Thu Apr 10 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.9.92-alt1.20080408
- new svn (see "Upgrading from 4.4 to 5.0")

* Tue Mar 11 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.4-alt1
- new version

* Tue Mar 04 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.3.1-alt1
- new version

* Wed Feb 20 2008 Sergey Y. Afonin <asy@altlinux.ru> 4.2-alt1
- new version

* Fri Sep 21 2007 Sergey Y. Afonin <asy@altlinux.ru> 4.1.1-alt3.svn20070810
- fixed #12864 (problem in reload section of init script)

* Thu Aug 16 2007 Sergey Y. Afonin <asy@altlinux.ru> 4.1.1-alt2.svn20070810
- added m4 to Requires

* Sat Aug 11 2007 Sergey Y. Afonin <asy@altlinux.ru> 4.1.1-alt1.svn20070810
- new version, Relicense everything under the GPLv3

* Tue May 29 2007 Sergey Y. Afonin <asy@altlinux.ru> 4.0-alt2
- added "-C /dev/null" in calling of   makemap in Makefile
- correcded reply when last_poll_recv = "nothing"

* Sat May 12 2007 Sergey Y. Afonin <asy@altlinux.ru> 4.0-alt1
- new version
- changes in mailfromd.rc
  default value for graylist_exclude set to "\n"

* Thu May 10 2007 Sergey Y. Afonin <asy@altlinux.ru> 3.1.92-alt0.20070510
- new svn
- added makemap to Requires

* Wed May 09 2007 Sergey Y. Afonin <asy@altlinux.ru> 3.1.92-alt0.20070508
- new svn
- created some different configurations (%name-cfg_clamav, %name-cfg_full)
- fixed: removing %_localstatedir/*.db instead of compacting in %%post (#11666)
- changes in mailfromd.rc 
  reply changed for "when not_found"
  some functions moved to userfunctions.rc
  common witelist
  fixed:
    ${client_addr} -> ${client_ptr} in massallocated_hit call

* Mon Apr 02 2007 Sergey Y. Afonin <asy@altlinux.ru> 3.1.91-alt0.20070403
- new svn, uncompatible changes since alt0.20070322:
  need to replace all occurrences of `next' with `pass'
- added executing "mailfromd --compact --all" in %%post and in %_sysconfdir/cron.daily
- changes in %_sysconfdir/sysconfig/mailfromd:
  moved definitions of variable to /etc/mailfromd/localconf.rc
- changes in localconf.rc
  added
   \#pragma option port
   clamd_port
   massallocated_regexps
  renamed "trusted_networks" to "massallocated_chk_exclude"
  \#pragma stacksize 16383 (resizable stack now)
  changed format of massallocated_chk_exclude
- changes in mailfromd.rc 
  all which correspond to localconf.rc
  common white list (changes is not compatible with previous white lists)
  ${client_addr} used in prog helo, you must update Milter.macros.helo in sendmail.cf

* Thu Mar 22 2007 Sergey Y. Afonin <asy@altlinux.ru> 3.1.91-alt0.20070322
- new svn
  (see documentation for checking uncompatible changes in mailfromd.rc
  "Upgrading from 3.1.x to 3.2" section)
- updated Summary
- changes in mailfromd.rc:
  converted to 3.2 format
  moved all host specific definitions to %_sysconfdir/sysconfig/mailfromd
  added "catch failure" for message_header_decode in "prog header"
- changes in %_sysconfdir/sysconfig/mailfromd:
  added 
   -v ehlo_domain=`hostname`
   -v virusmaster="admvirus@localhost"
   -v explain_msg=''
   -v trusted_networks="127.0.0.0/8,192.168.0.0/16,172.16.0.0/12,10.0.0.0/8"

* Thu Mar 15 2007 Sergey Y. Afonin <asy@altlinux.ru> 3.1.4-alt1
- new version
- changed Summary
- changes in mailfromd.rc:
  \#pragma stacksize 65535 (for "prog header")
  connect to clamd via local socket

* Thu Jan 11 2007 Sergey Y. Afonin <asy@altlinux.ru> 3.1.2-alt2
- fixed: Makefile missed in %%files
- added: *.db generation in %%post

* Wed Jan 10 2007 Sergey Y. Afonin <asy@altlinux.ru> 3.1.2-alt1
- new version
- changed: flex to flex-old in BuildRequires (removed mailfromd-flex2.5.4a-to-flex2.5.33.patch)
- added: /etc/maildromd/Makefile
- added: /etc/maildromd/{lists.d,lists.d.shared}
- added: /etc/maildromd/{whitelist_graylist,whitelist_massalocated}
- added: mailfromd-message_header_code.patch (from CVS)
  (message_header_decode and message_header_encode support)
- changes in mailfromd.rc:
  added graylist section
  some modifications in "prog envfrom"

* Wed Dec 13 2006 Sergey Y. Afonin <asy@altlinux.ru> 3.1.1-alt1
- new version
  (see documentation for checking uncompatible changes in mailfromd.rc)
- changed: moved configuration files from /etc/mail to /etc/mailfromd
- changed: replaced orgiginal mailfromd.rc
- changed: version is not necessary now in --with-berkeley-db=4
- changes in mailfromd.rc:
  added variables for using in templates:
    msg_header
    msg_header_last_received
    infected_received_from
    mail_from
    rcpt_to
    queue_id
  modified regular expressions for detection mass allocated networks
  added ClamAV section (mailutils-1.0-alt4 or latest required)

* Tue Nov 07 2006 Sergey Y. Afonin <asy@altlinux.ru> 3.0-alt1
- new version
- added: mailfromd-flex2.5.4a-to-flex2.5.33.patch
- changed: description and summary

* Thu Oct 05 2006 Sergey Y. Afonin <asy@altlinux.ru> 2.0.1-alt2
- fixed: change LDFLAGS="-lresolv" to export LIBS="-lresolv" (for x86_64 build)

* Fri Sep 22 2006 Sergey Y. Afonin <asy@altlinux.ru> 2.0.1-alt1
- New version
- changed: added --with-berkeley-db=4
- added: post_service and preun_service

* Fri Sep 22 2006 Sergey Y. Afonin <asy@altlinux.ru> 2.0-alt1
- New version

* Thu Aug 03 2006 Sergey Y. Afonin <asy@altlinux.ru> 1.4-alt2
- fixed: add LDFLAGS="-lresolv" (it is not added automatically on x86_64)

* Sat Jan 21 2006 Sergey Y. Afonin <asy@altlinux.ru> 1.4-alt1
- Initial release for AltLinux
